unit Main;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ToolWin,
  ComCtrls,
  ExtCtrls,
  untPropertyGrid,
  untPGData, ActnList, Grids;


type
  TForm1 = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    CheckBox1: TCheckBox;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    ActionList1: TActionList;
    Action1: TAction;
    Action2: TAction;
    Action3: TAction;
    Action4: TAction;
    Action5: TAction;
    Memo1: TMemo;
    pg: TPropertyGrid;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    procedure PGdd(Sender: TObject; AList: TCompList);
    { Private declarations }
  public
    { Public declarations }
//    pg : TPropertyGrid;
  end;

var
  Form1: TForm1;

implementation


{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
//  pg := TPropertyGrid.Create(self);
  pg.Parent := Self;
  pg.Align := alLeft;
  pg.PGGetCompInstances := PGdd;
end;


procedure TForm1.PGdd(Sender : TObject; AList : TCompList);
begin
  AList.Add(Self);

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  pg.CurrentObject := Sender;
end;

procedure TForm1.Panel1Click(Sender: TObject);
begin
  pg.CurrentObject := Sender;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  pg.MultiSelect := CheckBox1.Checked;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
	ms : TMemoryStream;
  ss : TStringStream;
begin
	ms := TMemoryStream.Create;
  try
  	ms.WriteComponent(pg);
    ms.Seek(0, soFromBeginning);
    ss := TStringStream.Create('');
    try
	    ObjectBinaryToText(ms, ss);
  	  Memo1.Lines.Text := ss.DataString
    finally
    end;
    	ss.Free;
  finally
  	ms.Free;
  end;


end;

initialization
	Registerclasses([TAction])

end.

